import { useRef, useEffect } from 'react';
import { select } from 'd3';

// D3 as React Component
export const D3Component = ({
  d3Data,
  circleSize
}) => {
  // useRef to access the raw DOM -> useEffect to grab the DOM after it is created
  const gRef = useRef();
  useEffect(() => {
    // Do D3 stuffs
    const g = select(gRef.current)
      .selectAll('circle').data(d3Data);
    
    const gEnter = g.enter().append('circle');
    gEnter
    	.merge(g)
    		.attr('cx', d => d*50 + 50)
    		.attr('cy', 200)
    		.attr('r', circleSize ? circleSize : 1);
	
    g.exit().remove();
  }, [d3Data, circleSize]);
	
  return <g ref={gRef} />;
};
